/*
llp_ctrln.hh

This C++ header file defines the NML Messages used for command and status by LLP_CTRL_MODULE
Template Version 1.1

MODIFICATIONS:
Mon Dec 25 22:12:35 EST 2000	Created by rcsdesign.

*/

// Prevent Multiple Inclusion
#ifndef LLP_CTRLN_HH
#define LLP_CTRLN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions

// Predefined type files
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.
#define PLANT_ORDER 6
#define CTRL_ORDER 6
#define LOOKAHEAD_HORIZON 3
#define NUM_DIFF_CTRL 10

// Define the integer type ids.
//  RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

#define LLP_CTRL_STATUS_TYPE 1000
#define LLP_CTRL_HALT_TYPE 1001
#define LLP_CTRL_INIT_TYPE 1002
#define LLP_CTRL_RUN_TYPE 1003
#define LLP_CTRL_SET_CTRL_INPUT_TYPE 1004
//  RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the NML Message Classes

// Status Class
class LLP_CTRL_STATUS : public RCS_STAT_MSG
{
public:

	// Normal Constructor
	LLP_CTRL_STATUS();

	// Constructor used by derived classes
	LLP_CTRL_STATUS(NMLTYPE t, size_t s) :  RCS_STAT_MSG(t,s) {};

	// CMS Update Function
	void update(CMS *);

  // Place custom variables here.
  double best_ctrl[CTRL_ORDER];
  double plant_state[PLANT_ORDER];

};

// Command Classes

class LLP_CTRL_HALT : public RCS_CMD_MSG
{
public:

	//Constructor
	LLP_CTRL_HALT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class LLP_CTRL_INIT : public RCS_CMD_MSG
{
public:

	//Constructor
	LLP_CTRL_INIT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class LLP_CTRL_RUN : public RCS_CMD_MSG
{
public:

	//Constructor
	LLP_CTRL_RUN();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double desired_plant_state[PLANT_ORDER];

};

class LLP_CTRL_SET_CTRL_INPUT : public RCS_CMD_MSG
{
public:

	//Constructor
	LLP_CTRL_SET_CTRL_INPUT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  int num_input_to_set;
  double ctrl_input_to_set[CTRL_ORDER];

};

// Declare NML format function
extern int llp_ctrlFormat(NMLTYPE, void *, CMS *);

#endif 	// LLP_CTRLN_HH
