/*
llp_ctrl.cc

This C++ file defines member functions for the class LLP_CTRL_MODULE
It was generated with rcsdesign
with template version 1.1

MODIFICATIONS:
Mon Dec 25 22:12:36 EST 2000	Created with RCS-Design tool.

*/

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "llp_ctrl.hh" 	// LLP_CTRL_MODULE definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "llp_ctrln.hh" 	// NML Commands and Status definitions for llp_ctrl
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Constructor
LLP_CTRL_MODULE::LLP_CTRL_MODULE(int _is_base_class)
  : LLP(PLANT_ORDER, CTRL_ORDER, LOOKAHEAD_HORIZON, NUM_DIFF_CTRL)
{

	// Initialize the NML channels if this module is not being used as the base class for another module.
	if(!_is_base_class)
	{
		INITIALIZE_NML();
	}
	// Add additional code to initialize the module here.
        if (llp_err != LLP_NO_ERROR)
          {
            logError("Error in creating LLP_CTRL_MODULE object!!!");
            status = RCS_ERROR; // let my supervisor know I have a problem.
          }

}

// Overloaded Virtual Functions

/*
INITIALIZE_NML

The INITIALIZE_NML function is ussually called only once from within the
constructor. It should not be called if a derived class will also call it.

*/
void LLP_CTRL_MODULE::INITIALIZE_NML()
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	setErrorLogChannel(new NML(nmlErrorFormat, "errlog", "llp_ctrl", "llp_module.nml"));
	setCmdChannel(new RCS_CMD_CHANNEL(llp_ctrlFormat, "llp_ctrl_cmd", "llp_ctrl", "llp_module.nml"));
	llp_ctrl_status = new LLP_CTRL_STATUS();
	setStatChannel(new RCS_STAT_CHANNEL(llp_ctrlFormat, "llp_ctrl_sts", "llp_ctrl", "llp_module.nml"), llp_ctrl_status);
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


}

/*
PRE_PROCESS

The PRE_PROCESS function is called every cycle after the command and
subordinates status have been read but before DECISION_PROCESS is called.
It is intended to be used for tasks such as sensory processing that should
be performed every cycle regardless of the current command or state.
*/
void LLP_CTRL_MODULE::PRE_PROCESS()
{
	// Pre-Processing Code
  
  // Measure and/or calculate the current system state
  // Here we just assign them to zero
  for(int ii = 0; ii < plant_order; ii++)
    {
      plant_state[ii] = 0.0;
    }

}

/*
DECISION_PROCESS

The DECISION_PROCESS function is called every cycle as long as there is a non-zero command.
It is expected to call a command function based on commandInData->type.
*/
void LLP_CTRL_MODULE::DECISION_PROCESS()
{
	switch(commandInData->type)
	{
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	case LLP_CTRL_INIT_TYPE:
		INIT((LLP_CTRL_INIT *)commandInData);
		break;

	case LLP_CTRL_HALT_TYPE:
		HALT((LLP_CTRL_HALT *)commandInData);
		break;

	case LLP_CTRL_RUN_TYPE:
		RUN((LLP_CTRL_RUN *)commandInData);
		break;

	case LLP_CTRL_SET_CTRL_INPUT_TYPE:
		SET_CTRL_INPUT((LLP_CTRL_SET_CTRL_INPUT *)commandInData);
		break;
		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	default:
		logError("The command %d is not recognized.",commandInData->type);
		break;
	}
}

/*
POST_PROCESS

The POST_PROCESS function is called every cycle after DECISION_PROCESS is called
but before the status and the subordinates commands  have been written.
It is intended to be used for tasks such as output filters that should
be performed every cycle regardless of the current command or state.
*/
void LLP_CTRL_MODULE::POST_PROCESS()
{
	// Post-Processing Code

  // Report the current system state
  memcpy(llp_ctrl_status->plant_state, plant_state, 
	 plant_order*sizeof(double));

  // Report the current best control input
  memcpy(llp_ctrl_status->best_ctrl, best_ctrl, 
	 ctrl_order*sizeof(double));

}

// Command Functions

/*
INIT

Parameter(s):
LLP_CTRL_INIT *cmd_in -- NML Message sent from superior.

Most Modules will have an INIT command.
The INIT function is expected to initialize any variables that may be
in an uninitialized or unknown state, send INIT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.
*/
void LLP_CTRL_MODULE::INIT(LLP_CTRL_INIT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		// Send an INIT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


		stateNext(S1);
		// Reinitialize variables here.

	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
HALT

Parameter(s):
LLP_CTRL_HALT *cmd_in -- NML Message sent from superior.

Most Modules will have an HALT command.
The HALT function is expected to stop any motion or command execution,
send HALT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.
*/
void LLP_CTRL_MODULE::HALT(LLP_CTRL_HALT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		//Send a HALT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

		stateNext(S1);
	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
RUN

Parameter(s):
LLP_CTRL_RUN *cmd_in -- NML Message sent from superior.

*/
void LLP_CTRL_MODULE::RUN(LLP_CTRL_RUN *cmd_in)
{
  double state_error;

	// Put state table for LLP_CTRL_RUN here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Find if in the desired state
      state_error = 0;
      for(int ii = 0; ii < plant_order; ii++)
	{
	  state_error = state_error 
	    + abs(cmd_in->desired_plant_state[ii] - plant_state[ii]);
	}

      if(state_error > 0)
	{
	  // Find the current best control
	  find_ctrl(best_ctrl);
	}
      else
	{
	  // We are already at the desired state
	  for(int ii = 0; ii < ctrl_order; ii++)
	    {
	      best_ctrl[ii] = 0;
	    }

          status = RCS_DONE;
          stateNext(S2);
 	}
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
  
}

/*
SET_CTRL_INPUT

Parameter(s):
LLP_CTRL_SET_CTRL_INPUT *cmd_in -- NML Message sent from superior.

*/
void LLP_CTRL_MODULE::SET_CTRL_INPUT(LLP_CTRL_SET_CTRL_INPUT *cmd_in)
{
	// Put state table for LLP_CTRL_SET_CTRL_INPUT here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Set the specified inpit
      set_ctrl_input(cmd_in->num_input_to_set, cmd_in->ctrl_input_to_set);

      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

